registerInputEvent(fxDtsBrick,"onMinigameActivate","Self fxDtsBrick\tTargetPlayer Player\tTargetClient GameConnection\tSourcePlayer Player\tSourceClient GameConnection\tMinigame Minigame");
$Event_Minigame::onMinigameActivateList = inputEvent_GetInputEventIdx("onMinigameActivate");
package Event_MinigameActivate
{
   function Player::ActivateStuff(%obj)
   {
      %r=containerRaycast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),10)),%mask,%obj);
      if(isObject(%col=firstWord(%r)))
      {
         if(!isObject(%col.client)||!isObject(%obj.client))
            return;
         if(getMinigameFromObject(%col)==%mini=getMinigameFromObject(%obj))
         {
            for(%i=0;%i<getWordCount($Event_Minigame::onMinigameActivateList);%i++)
            {
               %brick = getWord($Event_Minigame::onMinigameActivateList,%i);
               if(isObject(%brick))
               {
                  if(getMinigameFromObject(getBrickGroupFromObject(%brick)) == %mini)
                  {
                     if(%mini.useAllPlayersBricks || (!%mini.useAllPlayersBricks && getBrickGroupFromObject(%brick) == getBrickGroupFromObject(%client)))
                     {
                        $inputTarget_Self = %brick;
                        $inputTarget_TargetPlayer = %col;
                        $inputTarget_TargetClient = %col.client;
                        $inputTarget_SourcePlayer = %obj;
                        $inputTarget_SourceClient = %obj.client;
                        $inputTarget_Minigame = %mini;
                        %brick.processInputEvent("onMinigameActivate",%obj.client);
                     }
                  }
               }
            }
         }
      }
   }
   function serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4)
   {
      if(%input == $Event_Minigame::onMinigameActivateList)
         $Event_Minigame::onMinigameActivateList = addItemToList($Event_Minigame::onMinigameActivateList,%client.wrenchBrick);
      return Parent::serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4);
   }
   function serverCmdClearEvents(%client)
   {
      if(hasItemOnList($Event_Minigame::onMinigameActivateList,%client.wrenchBrick))
         $Event_Minigame::onMinigameActivateList = removeItemFromList($Event_Minigame::onMinigameActivateList,%client.wrenchBrick);
      Parent::serverCmdClearEvents(%client);
   }
   function fxDtsBrick::onDeath(%brick)
   {
      if(hasItemOnList($Event_Minigame::onMinigameActivateList,%brick))
         $Event_Minigame::onMinigameActivateList = removeItemFromList($Event_Minigame::onMinigameActivateList,%brick);
      Parent::onDeath(%brick);
   }
};
activatePackage(Event_MinigameActivate);
function addItemToList(%string,%item)
{
   if(hasItemOnList(%string,%item))
      return %string;

   if(%string $= "")
      return %item;
   else
      return %string SPC %item;
}
function hasItemOnList(%string,%item)
{
   for(%i=0;%i<getWordCount(%string);%i++)
   {
      if(getWord(%string,%i) $= %item)
         return 1;
   }
   return 0;
}
function removeItemFromList(%string,%item)
{
   if(!hasItemOnList(%string,%item))
      return %string;

   for(%i=0;%i<getWordCount(%string);%i++)
   {
      if(getWord(%string,%i) $= %item)
      {
         if(%i $= 0)
            return getWords(%string,1,getWordCount(%string));
         else if(%i $= getWordCount(%string)-1)
            return getWords(%string,0,%i-1);
         else
            return getWords(%string,0,%i-1) SPC getWords(%string,%i+1,getWordCount(%string));
      }
   }
}
